<?php

namespace Drupal\edlp_ajax\Controller;

use Drupal\Core\Controller\ControllerBase;
use Symfony\Component\HttpFoundation\Request;
use Drupal\Core\Url;
use Drupal\menu_link_content\Entity\MenuLinkContent;
use Symfony\Component\HttpFoundation\JsonResponse;


class EdlpAjaxController extends ControllerBase {

  private function query() {
    $this->entity = entity_load($this->entity_type, $this->id);
  }

  private function toRenderable(){
    $this->query();

    if($this->entity){
      return array(
        "#theme"=>'edlp_ajax',
        "#entity_type" => $this->entity_type,
        '#entity' => $this->entity,
        '#view_mode' => $this->viewmode,
      );
    }else{
      return array(
        '#markup'=>'404! '.$this->entity_type.' '.$this->id." not found!"
      );
    }
  }

  /**
   * Get entity as json through ajax.
   *
   * @return json
   */
  public function entityjson($entity_type, $id, $viewmode) {
    $this->entity_type = $entity_type;
    $this->id = $id;
    $this->viewmode = $viewmode;

    $renderable = $this->toRenderable();
    $rendered = render($renderable);

    switch($this->entity_type){
      case 'node':
        $bundle = $this->entity->getType();
        break;
      case 'taxonomy_term':
        $bundle = $this->entity->bundle();
        break;
      default:
        $bundle = NULL;
    }

    $data = [
      'test' => 'hello edlp ajax',
      'id' => $this->id,
      'view_mode' => $this->viewmode,
      'bundle' => $bundle,
      'entity_type' => $this->entity_type,
      'rendered'=> $rendered,
    ];

    // if content type page (productions) get the menu items
    if($bundle == "page"){
      $menuLinkManager = \Drupal::service('plugin.manager.menu.link');
      $links = $menuLinkManager->loadLinksByRoute('entity.node.canonical', array('node' => $this->id), 'productions');
      // dpm($links, 'links');
      $menu_parents = array();
      foreach ($links as $link) {
        $parents = $menuLinkManager->getParentIds($link->getPluginId());
        // dpm($parents, 'parents');
        foreach ($parents as $parent_id) {
          $parent = $menuLinkManager->getInstance(array('id'=>$parent_id));
          // dpm($parent, 'parent');
          $url = $parent->getUrlObject();
          $sys_path = $url->getInternalPath();
          // dpm($sys_path);
          $menu_parents[] = $sys_path;
        }
      }
      $data['menu_parents'] = $menu_parents;
    }

    $response = new JsonResponse();
    $response->setData($data);
    return $response;

    // return array(
    //   '#markup'=>'hello'
    // );
  }

}
